﻿unit Unit1;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants,
  System.Classes, Vcl.Graphics, Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.Menus,
  Vcl.ComCtrls, Vcl.ToolWin, Vcl.ImgList, Vcl.Grids, Vcl.DBGrids, Data.DB,
  IdHashMessageDigest, Vcl.StdCtrls, DBGridEhGrouping, ToolCtrlsEh,
  DBGridEhToolCtrls, DynVarsEh, EhLibVCL, GridsEh, DBAxisGridsEh, DBGridEh,
  Data.Win.ADODB, EhLibADO, DbUtilsEh, Registry, ShellApi;

type
  TfMain = class(TForm)
    mMain: TMainMenu;
    N5: TMenuItem;
    N6: TMenuItem;
    N7: TMenuItem;
    N8: TMenuItem;
    N10: TMenuItem;
    N13: TMenuItem;
    N14: TMenuItem;
    N16: TMenuItem;
    N19: TMenuItem;
    N22: TMenuItem;
    N23: TMenuItem;
    N24: TMenuItem;
    ilMain: TImageList;
    sbMain: TStatusBar;
    dsMain: TDataSource;
    N1: TMenuItem;
    dsStock: TDataSource;
    printMenu: TPopupMenu;
    N9: TMenuItem;
    N12: TMenuItem;
    N17: TMenuItem;
    qInReport: TADOQuery;
    qInReportid: TAutoIncField;
    qInReportdate: TDateTimeField;
    qInReportbrand_id: TSmallintField;
    qInReportdevtype_id: TSmallintField;
    qInReportstatus: TWideStringField;
    qInReportclient_id: TSmallintField;
    qInReportmodel: TWideStringField;
    qInReportserial: TWideStringField;
    qInReportuser_id: TSmallintField;
    qInReportdate_end: TDateTimeField;
    qInReportdefect: TWideMemoField;
    qInReportcomment: TWideMemoField;
    qInReportwarranty: TIntegerField;
    qInReportuser: TWideStringField;
    qInReportbrand: TWideStringField;
    qInReportdevtype: TWideStringField;
    qOutReport: TADOQuery;
    qOutReportname: TWideStringField;
    qOutReportprice: TFloatField;
    qOutReportquantity: TIntegerField;
    qOutReportmain_id: TIntegerField;
    qOutReporttotal: TFloatField;
    pcMain: TPageControl;
    tsFix: TTabSheet;
    ToolBar1: TToolBar;
    tbAdd: TToolButton;
    tbEdit: TToolButton;
    Separator1: TToolButton;
    tbDelete: TToolButton;
    ToolButton1: TToolButton;
    tbPrint: TToolButton;
    gFix: TDBGridEh;
    tsStock: TTabSheet;
    ToolBar3: TToolBar;
    tbStockIn: TToolButton;
    tbStockOut: TToolButton;
    Separator4: TToolButton;
    tbStockEdit: TToolButton;
    gStock: TDBGridEh;
    tsKassa: TTabSheet;
    ToolBar2: TToolBar;
    tbKassaIn: TToolButton;
    tbKassaOut: TToolButton;
    ToolButton5: TToolButton;
    tbKassaEdit: TToolButton;
    DBGridEh1: TDBGridEh;
    dsKassa: TDataSource;
    qSumma: TADOQuery;
    qSummaid: TAutoIncField;
    qSummasumWork: TFloatField;
    qSummasumStock: TFloatField;
    qSummasumAll: TFloatField;
    N2: TMenuItem;
    qInReportclient_name: TWideStringField;
    qInReportclient_phone: TWideStringField;
    qInReportdiscount: TIntegerField;
    N3: TMenuItem;
    procedure N7Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure N8Click(Sender: TObject);
    procedure N24Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure N22Click(Sender: TObject);
    procedure N14Click(Sender: TObject);
    procedure N16Click(Sender: TObject);
    procedure N11Click(Sender: TObject);
    procedure N10Click(Sender: TObject);
    procedure N19Click(Sender: TObject);
    procedure tbEditClick(Sender: TObject);
    procedure tbStockEditClick(Sender: TObject);
    procedure tbStockInClick(Sender: TObject);
    procedure tbStockOutClick(Sender: TObject);
    procedure tbAddClick(Sender: TObject);
    procedure N9Click(Sender: TObject);
    procedure N12Click(Sender: TObject);
    procedure N17Click(Sender: TObject);
    procedure tbDeleteClick(Sender: TObject);
    procedure N1Click(Sender: TObject);
    procedure pcMainChange(Sender: TObject);
    procedure tbKassaInClick(Sender: TObject);
    procedure tbKassaOutClick(Sender: TObject);
    procedure tbKassaEditClick(Sender: TObject);
    procedure N2Click(Sender: TObject);
    procedure qSummaAfterOpen(DataSet: TDataSet);
    procedure N3Click(Sender: TObject);
  private
    { Private declarations }
  public
    procedure DisplayHint(Sender: TObject);
    function md5(s: string): string;
    var db:string;
        user_name:string;
        user_id:integer;
        OO, Document, Cell, Sheet, Sheets: Variant;
  end;

var
  fMain: TfMain;

implementation

{$R *.dfm}

uses Unit3, Unit4, Unit2, inifiles, Unit6, Unit8, Unit10, Unit14, Unit16,
     Unit18, Unit19, Unit21, Unit22, Unit26, Unit12, Unit13, Unit27;

function TfMain.md5(s: string): string;
begin
   Result := '';
   with TIdHashMessageDigest5.Create do begin
      try
         Result := AnsiLowerCase(HashStringAsHex(s));
      finally
         Free;
      end;
   end;
end;

procedure TfMain.DisplayHint(Sender: TObject);
   var
      Counter, NumComps: integer;
begin
   with Screen.ActiveForm do begin
      NumComps := ControlCount - 1;
      for Counter := 0 to NumComps do begin
         if (TControl(Controls[Counter]).Name = 'sbMain') then begin
            if (Application.Hint = '') then
               sbMain.Panels[0].Text := ''
            else
               sbMain.Panels[0].Text := Application.Hint;
            break;
         end;
      end;
   end;
end;

procedure SaveSettings;
   var
      reg: TRegistry;
begin
   reg := TRegistry.Create;
   reg.RootKey := HKEY_CURRENT_USER;
   reg.OpenKey('\SOFTWARE\SCAudit', true);
   reg.WriteInteger('Left', fMain.Left);
   reg.WriteInteger('Top', fMain.Top);
   reg.WriteInteger('Width', fMain.Width);
   reg.WriteInteger('Height', fMain.Height);
   reg.Free;
end;

procedure LoadSettings;
   var
      reg: TRegistry;
begin
   reg := TRegistry.Create;
   reg.RootKey := HKEY_CURRENT_USER;
   reg.OpenKey('\SOFTWARE\SCAudit', true);
   if reg.ValueExists('Left') then
      fMain.Left := reg.ReadInteger('Left');
   if reg.ValueExists('Top') then
      fMain.Top := reg.ReadInteger('Top');
   if reg.ValueExists('Width') then
      fMain.Width := reg.ReadInteger('Width');
   if reg.ValueExists('Height') then
      fMain.Height := reg.ReadInteger('Height');
   reg.free;
end;

procedure TfMain.FormCreate(Sender: TObject);
begin
   Application.OnHint := DisplayHint;
   DbUtilsEh.SQLFilterMarker := '1=1 AND'
end;

procedure TfMain.FormDestroy(Sender: TObject);
begin
   SaveSettings;
end;

procedure TfMain.FormShow(Sender: TObject);
   var
      Ini: TInifile;
      port:integer;
      user, pass, host, driver : string;
begin
   Ini:=TiniFile.Create(extractfilepath(paramstr(0))+'Config.ini');
   LoadSettings;
   user:=Ini.ReadString('MySQL','User','root');
   pass:=Ini.ReadString('MySQL','Password','000123zxc');
   host:=Ini.ReadString('MySQL','Host','127.0.0.1');
   port:=Ini.ReadInteger('MySQL','Port',3306);
   db:=Ini.ReadString('MySQL','DB','scbest');
   driver:=Ini.ReadString('MySQL','Driver','MySQL ODBC 5.3 Unicode Driver');
   DM.Conn.ConnectionString := 'Provider=MSDASQL.1;Password='+pass+';Persist Security Info=True;User ID='+user+';Extended Properties="DRIVER='+driver+';UID='+user+';PWD='+pass+';SERVER='+host+';DATABASE='+db+';PORT='+IntToStr(port)+';COLUMN_SIZE_S32=1;";Initial Catalog='+db;
   Ini.Free;
   DM.Conn.Open();
   DM.qMain.Open;
   DM.tUsers.Open;
   DM.qStock.Open;
   DM.qKassa.Open;
   DM.tBrand.Open;
   DM.qDevType.Open;
   if fLogin.ShowModal = mrOk then begin
      if md5(fLogin.Edit1.Text) = DM.tUserspassword.AsString then begin
         user_id := DM.tUsersid.AsInteger;
         user_name := DM.tUsersname.AsString;
         fMain.Caption := fMain.Caption+' - ['+user_name+']';
      end
      else begin
         Application.MessageBox('Неверный пароль', 'Ошибка', MB_ICONERROR);
         fMain.Close;
      end;
   end
   else begin
      fMain.Close;
   end;
end;

procedure TfMain.N10Click(Sender: TObject);
begin
   DM.tConfig.Open;
   DM.tConfig.Edit;
   if fConfig.ShowModal = mrOk then begin
      if DM.tConfig.Modified then
         DM.tConfig.Post;
   end;
   DM.tConfig.Close;
end;

procedure TfMain.N11Click(Sender: TObject);
begin
   fClient.Caption := fMain.Caption + ' - Клиенты';
   fClient.ShowModal;
end;

procedure TfMain.N12Click(Sender: TObject);
  var
    TS, Style: TStringList;
    strFile, rows: string;
    total, discount : Double;
begin
   if (DM.qMainstatus.AsString = 'Выдан') AND (DM.qMaindate_end.AsString <> '') then begin
      if qInReport.Active then
         qInReport.Close;
      if qOutReport.Active then
         qOutReport.Close;
      qOutReport.Parameters[0].Value := DM.qMainid.AsInteger;
      qOutReport.Parameters[1].Value := DM.qMainid.AsInteger;
      qOutReport.Open;
      qInReport.Parameters[0].Value := DM.qMainid.AsInteger;
      qInReport.Open;
      TS := TStringList.Create;
      TS.LoadFromFile('Report\aktvidashi.html');
      Style := TStringList.Create;
      Style.LoadFromFile('Report\style.css');
      TS.Text := StringReplace(TS.Text, '{style}', Style.Text, [rfReplaceAll]);
      TS.Text := StringReplace(TS.Text, '{imgPath}', ExtractFilePath(ParamStr(0)), [rfReplaceAll]);
      rows := '';
      total := 0;
      while not qOutReport.Eof do begin
         rows := rows + '<tr><td>'+qOutReportname.AsString+'</td><td class="text-center">'+qOutReportquantity.AsString+' шт.</td><td class="text-center">'+CurrToStrF(qOutReportprice.AsFloat, ffNumber, 2)+' ₽</td><td class="text-center">'+CurrToStrF(qOutReporttotal.AsFloat, ffNumber, 2)+' ₽</td></tr>';
         total := total + qOutReporttotal.AsFloat;
         qOutReport.Next;
      end;

      if (total = 0) then begin
         rows := rows + '<tr><td colspan="4" class="text-center">БЕЗ РЕМОНТА</td></tr>';
      end;

      if (DM.qMaindiscount.AsInteger > 0) then begin
         discount := qSummasumAll.AsFloat * (DM.qMaindiscount.AsInteger / 100);
         total := total - discount;
         rows := rows + '<tr><td colspan="3" class="text-right"><b>Скидка ('+DM.qMaindiscount.AsString+'%)</b></td><td class="text-center">'+CurrToStrF(discount, ffNumber, 2)+' ₽</td></tr>';
      end;

      TS.Text := StringReplace(TS.Text, '{title}', 'Акт выполненных работ #'+qInReportid.AsString, [rfReplaceAll]);
      TS.Text := StringReplace(TS.Text, '{number}', qInReportid.AsString, [rfReplaceAll]);
      TS.Text := StringReplace(TS.Text, '{date}', qInReportdate.AsString, [rfReplaceAll]);
      TS.Text := StringReplace(TS.Text, '{date-out}', qInReportdate_end.AsString, [rfReplaceAll]);
      TS.Text := StringReplace(TS.Text, '{fio}', qInReportclient_name.AsString, [rfReplaceAll]);
      TS.Text := StringReplace(TS.Text, '{phone}', qInReportclient_phone.AsString, [rfReplaceAll]);
      TS.Text := StringReplace(TS.Text, '{device-type}', qInReportdevtype.AsString, [rfReplaceAll]);
      TS.Text := StringReplace(TS.Text, '{brand}', qInReportbrand.AsString, [rfReplaceAll]);
      TS.Text := StringReplace(TS.Text, '{model}', qInReportmodel.AsString, [rfReplaceAll]);
      TS.Text := StringReplace(TS.Text, '{serial}', qInReportserial.AsString, [rfReplaceAll]);
      TS.Text := StringReplace(TS.Text, '{warranty}', qInReportwarranty.AsString, [rfReplaceAll]);
      TS.Text := StringReplace(TS.Text, '{rows}', rows, [rfReplaceAll]);
      TS.Text := StringReplace(TS.Text, '{total}', CurrToStrF(total, ffNumber, 2), [rfReplaceAll]);
      strFile := GetEnvironmentVariable('temp')+'\aktvidashi-'+qInReportid.AsString+FormatDateTime('-ddmmyy-hms', Now)+'.html';
      TS.SaveToFile(strFile);
      qInReport.Close;
      qOutReport.Close;
      ShellExecute(Handle, 'open', PChar(strFile), nil, nil, SW_SHOWNORMAL);
   end
   else begin
      Application.MessageBox('Печать невозможна, т.к. не установлен статус «Выдан»', 'Ошибка', MB_ICONERROR);
   end;
end;

procedure TfMain.N14Click(Sender: TObject);
begin
  fDevType.Caption := fMain.Caption + ' - Тип устройства';
  DM.tDevType.Open;
  fDevType.ShowModal;
  DM.tDevType.Close;
end;

procedure TfMain.N16Click(Sender: TObject);
begin
  fBrand.Caption := fMain.Caption + ' - Бренды';
  DM.tBrand.Open;
  fBrand.ShowModal;
  DM.tBrand.Close;
end;

procedure TfMain.N17Click(Sender: TObject);
  var
    TS, Style: TStringList;
    strFile, rows: string;
    total : Double;
begin
  if qInReport.Active then
     qInReport.Close;
  if qOutReport.Active then
     qOutReport.Close;
  qOutReport.Parameters[0].Value := DM.qMainid.AsInteger;
  qOutReport.Parameters[1].Value := DM.qMainid.AsInteger;
  qOutReport.Open;
  qInReport.Parameters[0].Value := DM.qMainid.AsInteger;
  qInReport.Open;
  TS := TStringList.Create;
  TS.LoadFromFile('Report\fix.html');
  Style := TStringList.Create;
  Style.LoadFromFile('Report\style.css');
  TS.Text := StringReplace(TS.Text, '{style}', Style.Text, [rfReplaceAll]);
  TS.Text := StringReplace(TS.Text, '{imgPath}', ExtractFilePath(ParamStr(0)), [rfReplaceAll]);
  rows := '';
  total := 0;
  while not qOutReport.Eof do begin
     rows := rows + '<tr><td>'+qOutReportname.AsString+'</td><td class="text-center">'+qOutReportquantity.AsString+'</td><td class="text-center">'+CurrToStrF(qOutReportprice.AsFloat, ffNumber, 2)+' ₽</td><td class="text-center">'+CurrToStrF(qOutReporttotal.AsFloat, ffNumber, 2)+' ₽</td></tr>';
     total := total + qOutReporttotal.AsFloat;
     qOutReport.Next;
  end;

  TS.Text := StringReplace(TS.Text, '{title}', 'Лист ремонта #'+qInReportid.AsString, [rfReplaceAll]);
  TS.Text := StringReplace(TS.Text, '{number}', qInReportid.AsString, [rfReplaceAll]);
  TS.Text := StringReplace(TS.Text, '{date}', qInReportdate.AsString, [rfReplaceAll]);
  TS.Text := StringReplace(TS.Text, '{device-type}', qInReportdevtype.AsString, [rfReplaceAll]);
  TS.Text := StringReplace(TS.Text, '{brand}', qInReportbrand.AsString, [rfReplaceAll]);
  TS.Text := StringReplace(TS.Text, '{model}', qInReportmodel.AsString, [rfReplaceAll]);
  TS.Text := StringReplace(TS.Text, '{serial}', qInReportserial.AsString, [rfReplaceAll]);
  TS.Text := StringReplace(TS.Text, '{defect}', qInReportdefect.AsString, [rfReplaceAll]);
  TS.Text := StringReplace(TS.Text, '{rows}', rows, [rfReplaceAll]);
  TS.Text := StringReplace(TS.Text, '{total}', CurrToStrF(total, ffNumber, 2), [rfReplaceAll]);
  strFile := GetEnvironmentVariable('temp')+'\fix-'+qInReportid.AsString+FormatDateTime('-ddmmyy-hms', Now)+'.html';
  TS.SaveToFile(strFile);
  qInReport.Close;
  qOutReport.Close;
  ShellExecute(Handle, 'open', PChar(strFile), nil, nil, SW_SHOWNORMAL);
end;

procedure TfMain.N19Click(Sender: TObject);
begin
  fValue.Caption := fMain.Caption + ' - ТМЦ';
  DM.tDevType.Open;
  fValue.qValue.Open;
  fValue.ShowModal;
  fValue.qValue.Close;
  DM.tDevType.Close;
end;

procedure TfMain.N1Click(Sender: TObject);
begin
   fReport.ShowModal;
end;

procedure TfMain.N22Click(Sender: TObject);
begin
  fFixPrice.Caption := fMain.Caption + ' - Виды работ и цены';
  DM.tFixPrice.Open;
  fFixPrice.ShowModal;
  DM.tFixPrice.Close;
end;

procedure TfMain.N24Click(Sender: TObject);
begin
  fUsers.Caption := fMain.Caption + ' - Пользователи';
  DM.tUsers.Open;
  fUsers.ShowModal;
  DM.tUsers.Close;
end;

procedure TfMain.N2Click(Sender: TObject);
begin
   fDB.ShowModal;
end;

procedure TfMain.N3Click(Sender: TObject);
begin
   DM.qSMS.Open;
   fSMS.ShowModal;
   DM.qSMS.Close;
end;

procedure TfMain.N7Click(Sender: TObject);
begin
   fMain.Close;
end;

procedure TfMain.N8Click(Sender: TObject);
begin
    fAbout.ShowModal;
end;

procedure TfMain.N9Click(Sender: TObject);
  var
    TS, Style: TStringList;
    strFile : string;
begin
  if qInReport.Active then
     qInReport.Close;
  qInReport.Parameters[0].Value := DM.qMainid.AsInteger;
  qInReport.Open;
  TS := TStringList.Create;
  TS.LoadFromFile('Report\aktpriema.html');
  Style := TStringList.Create;
  Style.LoadFromFile('Report\style.css');
  TS.Text := StringReplace(TS.Text, '{style}', Style.Text, [rfReplaceAll]);
  TS.Text := StringReplace(TS.Text, '{imgPath}', ExtractFilePath(ParamStr(0)), [rfReplaceAll]);
  TS.Text := StringReplace(TS.Text, '{title}', 'Акт приема оборудования в ремонт #'+qInReportid.AsString, [rfReplaceAll]);
  TS.Text := StringReplace(TS.Text, '{number}', qInReportid.AsString, [rfReplaceAll]);
  TS.Text := StringReplace(TS.Text, '{date}', qInReportdate.AsString, [rfReplaceAll]);
  TS.Text := StringReplace(TS.Text, '{fio}', qInReportclient_name.AsString, [rfReplaceAll]);
  TS.Text := StringReplace(TS.Text, '{phone}', qInReportclient_phone.AsString, [rfReplaceAll]);
  TS.Text := StringReplace(TS.Text, '{device-type}', qInReportdevtype.AsString, [rfReplaceAll]);
  TS.Text := StringReplace(TS.Text, '{brand}', qInReportbrand.AsString, [rfReplaceAll]);
  TS.Text := StringReplace(TS.Text, '{model}', qInReportmodel.AsString, [rfReplaceAll]);
  TS.Text := StringReplace(TS.Text, '{serial}', qInReportserial.AsString, [rfReplaceAll]);
  TS.Text := StringReplace(TS.Text, '{defect}', qInReportdefect.AsString, [rfReplaceAll]);
  TS.Text := StringReplace(TS.Text, '{note}', qInReportcomment.AsString, [rfReplaceAll]);
  strFile := GetEnvironmentVariable('temp')+'\aktpriema-'+qInReportid.AsString+FormatDateTime('-ddmmyy-hms', Now)+'.html';
  TS.SaveToFile(strFile);
  ShellExecute(Handle, 'open', PChar(strFile), nil, nil, SW_SHOWNORMAL);
  qInReport.Close;
end;

procedure TfMain.pcMainChange(Sender: TObject);
begin
   DM.qMain.Requery();
   DM.qStock.Requery();
   DM.qKassa.Requery();
end;

procedure TfMain.qSummaAfterOpen(DataSet: TDataSet);
   var
      discount : Double;
begin
   if DM.qMaindiscount.AsInteger > 0 then begin
      discount := qSummasumAll.AsFloat * (DM.qMaindiscount.AsInteger / 100);
      sbMain.Panels[1].Text := ' Итого: ' +FloatToStr(qSummasumAll.AsFloat - discount)+' ₽ | Скидка: '+FloatToStr(discount) + ' ₽';     // Итого
   end
   else begin
      sbMain.Panels[1].Text := ' Итого: '+qSummasumAll.AsString+' ₽'; // Итого
   end;
end;

procedure TfMain.tbAddClick(Sender: TObject);
begin
   fMainEdit.qStockMove.Parameters[0].Value := -1;
   fMainEdit.qWorks.Parameters[0].Value := 0;
   fMainEdit.qSumma.Parameters[0].Value := 0;
   fMainEdit.qPhoto.Parameters[0].Value := 0;

   fMainEdit.qMainEdit.Open;
   fMainEdit.qMainEdit.Append;
   fMainEdit.qMainEditdate.AsDateTime := now();
   fMainEdit.qMainEdituser_id.AsInteger := user_id;
   fMainEdit.qMainEditstatus.AsString := 'Принят';
   if fMainEdit.ShowModal = mrOk then begin
     if fMainEdit.qMainEdit.Modified then
        fMainEdit.qMainEdit.Post;
   end;
   fMainEdit.qMainEdit.Close;
   DM.qMain.Requery();
end;

procedure TfMain.tbDeleteClick(Sender: TObject);
begin
   if Application.MessageBox('Удалить запись?', 'Подтверждение', MB_ICONQUESTION+MB_YESNO) = idYes then begin
      DM.qRemove.SQL.Text := 'DELETE FROM main WHERE id='+DM.qMainid.AsString;
      DM.qRemove.ExecSQL;
      DM.qMain.Requery();
   end;
end;

procedure TfMain.tbEditClick(Sender: TObject);
   var
      id:integer;
begin
   id := DM.qMain.RecNo;

   fMainEdit.qStockMove.Parameters[0].Value := DM.qMainid.AsInteger;
   fMainEdit.qWorks.Parameters[0].Value := DM.qMainid.AsInteger;
   fMainEdit.qSumma.Parameters[0].Value := DM.qMainid.AsInteger;
   fMainEdit.qPhoto.Parameters[0].Value := DM.qMainid.AsInteger;

   fMainEdit.qMainEdit.Parameters[0].Value := DM.qMainid.AsInteger;
   fMainEdit.qMainEdit.Open;
   fMainEdit.qMainEdit.Edit;
   if fMainEdit.ShowModal = mrOk then begin
      if fMainEdit.qMainEdit.Modified then
         fMainEdit.qMainEdit.Post;
   end;
   fMainEdit.qMainEdit.Close;
   DM.qMain.Requery();
   DM.qMain.MoveBy(id-1);
end;

procedure TfMain.tbStockInClick(Sender: TObject);
begin
   DM.qStock.Append;
   DM.qStockdate.AsDateTime := now();
   DM.qStockmoveIn.AsInteger := 1;
   DM.qStockuser_id.AsInteger := user_id;
   fStockEdit.qStockMove.Parameters[0].Value := 0;
   fStockEdit.qStockMove.Open;
   if fStockEdit.ShowModal = mrOk then begin
      if DM.qStock.Modified then
         DM.qStock.Post;
   end;
   DM.qStock.Cancel;
   DM.qStock.Requery();
   DM.qStock.First;
end;

procedure TfMain.tbStockOutClick(Sender: TObject);
begin
   DM.qStock.Append;
   DM.qStockdate.AsDateTime := now();
   DM.qStockmoveIn.AsInteger := 0;
   DM.qStockuser_id.AsInteger := user_id;
   if fStockEdit.ShowModal = mrOk then begin
      if DM.qStock.Modified then
         DM.qStock.Post;
   end;
   DM.qStock.Cancel;
   DM.qStock.Requery();
   DM.qStock.First;
end;

procedure TfMain.tbStockEditClick(Sender: TObject);
  var
    id:integer;
begin
  id := DM.qStock.RecNo;
  fStockEdit.qStockMove.Parameters[0].Value := DM.qStockid.Value;
  fStockEdit.qStockMove.Open;
  DM.qStock.Edit;
  if fStockEdit.ShowModal = mrOk then begin
    if DM.qStock.Modified then
      DM.qStock.Post;
  end;
  fStockEdit.qStockMove.Close;
  DM.qStock.Cancel;
  DM.qStock.Requery();
  DM.qStock.MoveBy(id-1);
end;

procedure TfMain.tbKassaInClick(Sender: TObject);
begin
  DM.qKassa.Append;
  DM.qKassadate.AsDateTime := now();
  DM.qKassamove.AsInteger := 1;
  DM.qKassauser_id.AsInteger := user_id;
  if fKassaEdit.ShowModal = mrOk then begin
    if DM.qKassa.Modified then
      DM.qKassa.Post;
   end;
   DM.qKassa.Cancel;
   DM.qKassa.Requery();
   DM.qKassa.First;
end;

procedure TfMain.tbKassaOutClick(Sender: TObject);
begin
  DM.qKassa.Append;
  DM.qKassadate.AsDateTime := now();
  DM.qKassamove.AsInteger := 0;
  DM.qKassauser_id.AsInteger := user_id;
  if fKassaEdit.ShowModal = mrOk then begin
    if DM.qKassa.Modified then
      DM.qKassa.Post;
   end;
   DM.qKassa.Cancel;
   DM.qKassa.Requery();
   DM.qKassa.First;
end;

procedure TfMain.tbKassaEditClick(Sender: TObject);
   var
      id:integer;
begin
   //ShowMessage(IntToStr(DM.qKassa.RecordCount));

   id := DM.qKassa.RecNo;
   DM.qKassa.Edit;
   if fKassaEdit.ShowModal = mrOk then begin
      if DM.qKassa.Modified then
         DM.qKassa.Post;
   end;
   DM.qKassa.Cancel;
   DM.qKassa.Requery();
   DM.qKassa.MoveBy(id-1);
end;

end.
