unit Unit13;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.Buttons, Vcl.ExtCtrls;

type
  TfDB = class(TForm)
    mRequest: TMemo;
    Panel1: TPanel;
    GroupBox1: TGroupBox;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    GroupBox2: TGroupBox;
    BitBtn3: TBitBtn;
    Button1: TButton;
    procedure BitBtn3Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  fDB: TfDB;

implementation

{$R *.dfm}

uses Unit2;

procedure TfDB.BitBtn3Click(Sender: TObject);
begin
   DM.qRequest.SQL.Text := mRequest.Lines.Text;
   DM.qRequest.ExecSQL;
end;

procedure TfDB.Button1Click(Sender: TObject);
begin
   DM.qRequest.SQL.Text := 'ALTER TABLE `main` ADD COLUMN `client_name` VARCHAR(250) NULL DEFAULT NULL AFTER `status`;';
   DM.qRequest.ExecSQL;
   DM.qRequest.SQL.Text := 'ALTER TABLE `main` ADD COLUMN `client_phone` VARCHAR(250) NULL DEFAULT NULL AFTER `client_name`;';
   DM.qRequest.ExecSQL;
   DM.qRequest.SQL.Text := 'SELECT m.*, c.name AS cname, c.phone AS cphone FROM `main` AS m LEFT JOIN `client` AS c ON c.id = m.client_id';
   DM.qRequest.Open;
   DM.qRequest.First;
   while not DM.qRequest.Eof do begin
      DM.qRequest.Edit;
      DM.qRequest.FieldByName('client_name').AsString := DM.qRequest.FieldByName('cname').AsString;
      DM.qRequest.FieldByName('client_phone').AsString := DM.qRequest.FieldByName('cphone').AsString;
      if DM.qRequest.Modified then
         DM.qRequest.Post;
      DM.qRequest.Next;
   end;
   DM.qRequest.Close;
   DM.qRequest.SQL.Text := '';
end;

end.
