unit Unit27;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, DBGridEhGrouping, ToolCtrlsEh,
  DBGridEhToolCtrls, DynVarsEh, Data.DB, EhLibVCL, GridsEh, DBAxisGridsEh,
  DBGridEh, Vcl.ComCtrls, Vcl.ToolWin, Vcl.ExtCtrls;

type
  TfSMS = class(TForm)
    pTop: TPanel;
    tbMain: TToolBar;
    tbAdd: TToolButton;
    tbEdit: TToolButton;
    tbDelete: TToolButton;
    DBGridEh1: TDBGridEh;
    dsSMS: TDataSource;
    procedure tbAddClick(Sender: TObject);
    procedure tbDeleteClick(Sender: TObject);
    procedure tbEditClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  fSMS: TfSMS;

implementation

{$R *.dfm}

uses Unit2, Unit28;

procedure TfSMS.tbAddClick(Sender: TObject);
begin
   DM.qSMS.Append;
   if fSMSEdit.ShowModal = mrOk then begin
      if DM.qSMS.Modified then
         DM.qSMS.Post;
   end;
   DM.qSMS.Cancel;
   DM.qSMS.Requery();
   DM.qSMS.Last;
end;

procedure TfSMS.tbDeleteClick(Sender: TObject);
begin
   if Application.MessageBox(' ?', '', MB_ICONQUESTION+MB_YESNO) = idYes then
      DM.qSMS.Delete;
end;

procedure TfSMS.tbEditClick(Sender: TObject);
   var
      id:integer;
begin
   id := DM.qSMS.RecNo;
   DM.qSMS.Edit;
   if fSMSEdit.ShowModal = mrOk then begin
      if DM.qSMS.Modified then
         DM.qSMS.Post;
   end;
   DM.qSMS.Cancel;
   DM.qSMS.Requery();
   DM.qSMS.MoveBy(id-1);
end;

end.
