unit Unit2;

interface

uses
  System.SysUtils, System.Classes, Data.DB, Data.Win.ADODB;

type
  TDM = class(TDataModule)
    Conn: TADOConnection;
    tUsers: TADOTable;
    tUsersid: TAutoIncField;
    tUserslogin: TWideStringField;
    tUsersname: TWideStringField;
    tUserspassword: TWideStringField;
    tUsersrights: TSmallintField;
    tFixPrice: TADOTable;
    tDevType: TADOTable;
    tDevTypeid: TAutoIncField;
    tDevTypename: TWideStringField;
    tBrand: TADOTable;
    tBrandid: TAutoIncField;
    tBrandname: TWideStringField;
    tConfig: TADOTable;
    tConfigid: TAutoIncField;
    tConfigname: TWideStringField;
    tConfiginn: TWideStringField;
    tConfigogrn: TWideStringField;
    tConfigaddress: TWideStringField;
    tConfigphone: TWideStringField;
    tDevTypeparent_id: TIntegerField;
    tValue: TADOTable;
    qMain: TADOQuery;
    qMainid: TAutoIncField;
    qMaindate: TDateTimeField;
    qMainbrand_id: TIntegerField;
    qMaindevtype_id: TIntegerField;
    qMainstatus: TWideStringField;
    qMainmodel: TWideStringField;
    qMainserial: TWideStringField;
    qMainuser_id: TIntegerField;
    qMaindate_end: TDateTimeField;
    qMaindefect: TWideMemoField;
    qMaincomment: TWideMemoField;
    qMainwarranty: TIntegerField;
    qMaindevtype: TWideStringField;
    qMainbrand: TWideStringField;
    qMainuser: TWideStringField;
    tFixPriceid: TAutoIncField;
    tFixPricedeviceType_id: TIntegerField;
    tFixPricename: TWideStringField;
    tFixPriceprice: TFloatField;
    tFixPricedescription: TWideMemoField;
    tValueid: TAutoIncField;
    tValuedeviceType_id: TIntegerField;
    tValuevendor: TWideStringField;
    tValuename: TWideStringField;
    tValueisFolder: TSmallintField;
    qStock: TADOQuery;
    qStockid: TAutoIncField;
    qStockdate: TDateField;
    qStockmoveIn: TSmallintField;
    qStockmain_id: TIntegerField;
    qStockbase: TWideStringField;
    qStockcomment: TWideMemoField;
    qStockuser_id: TIntegerField;
    qStockmove_in: TWideStringField;
    qStockuser: TWideStringField;
    qRemove: TADOQuery;
    qRequest: TADOQuery;
    tFixPricedeviceType: TStringField;
    tConfigsmsApi: TWideStringField;
    qDevType: TADOQuery;
    qDevTypeid: TAutoIncField;
    qDevTypename: TWideStringField;
    qDevTypeparent_id: TIntegerField;
    qKassa: TADOQuery;
    qKassaid: TAutoIncField;
    qKassadate: TDateField;
    qKassamove: TSmallintField;
    qKassamain_id: TIntegerField;
    qKassasumma: TFloatField;
    qKassabase: TWideStringField;
    qKassauser_id: TIntegerField;
    qKassamove_str: TWideStringField;
    qKassauser: TWideStringField;
    qKassacomment: TWideMemoField;
    qMaindiscount: TIntegerField;
    tUserspercent: TIntegerField;
    qMainclient_name: TWideStringField;
    qMainclient_phone: TWideStringField;
    qSMS: TADOQuery;
    qSMSid: TAutoIncField;
    qSMSstatus: TWideStringField;
    qSMStext: TWideStringField;
    procedure qMainAfterOpen(DataSet: TDataSet);
    procedure qMainAfterScroll(DataSet: TDataSet);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  DM: TDM;

implementation

{%CLASSGROUP 'Vcl.Controls.TControl'}

uses Unit1, Unit21;

{$R *.dfm}

procedure TDM.qMainAfterOpen(DataSet: TDataSet);
begin
if fMain.qSumma.Active then
      fMain.qSumma.Close;
   fMain.qSumma.Parameters[0].Value := DM.qMainid.AsInteger;
   fMain.qSumma.Open;
end;

procedure TDM.qMainAfterScroll(DataSet: TDataSet);
begin
   if fMain.qSumma.Active then
      fMain.qSumma.Close;
   fMain.qSumma.Parameters[0].Value := DM.qMainid.AsInteger;
   fMain.qSumma.Open;
end;

end.
